#include <cstdio>
#include <iomanip>
#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

class B {
public:
  double x_{0.0};
  double y_{1.0};
  double z_{0.0};
};

class A {
public:
  ~A();
  A();
  void f();
  void dump();
private:
  int x_;
  double y_;
  long z_[3];
  B* p_;
};

A::
~A()
{
  delete p_;
}

A::
A()
  : x_(53)
  , y_(42.1)
  , z_{3, 5, 7}
  , p_(nullptr)
{
  p_ = new B();
}

void
A::
f()
{
  cout << " &p_: " << hex << &p_ << dec <<endl;
  cout << "  p_: " << hex << p_ << dec <<endl;
  for (int i = 0; i < 3; ++i) {
    z_[i] += 1;
    cout << "addr: " << hex << &z_[i] << dec << " z_[" << i << "]: " << z_[i] << endl;
    cout << "  p_: " << hex << p_ << dec <<endl;
  };
}

void
A::
dump()
{
  cout << "A: " << x_ << " " << y_ << " "
       << z_[0] << " " << z_[1] << " "
       << z_[2] << " B: " << p_->x_
       << " " << p_->y_ << " "
       << p_->z_ << endl;
}

int
main()
{
  A aobj;
  aobj.f();
  aobj.dump();
}

